<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<title>magpar: tools/gmsh/gmshtoucd.py Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<link href="doxygen.css" rel="stylesheet" type="text/css"/>
</head>
<body>
<!-- Generated by Doxygen 1.6.3 -->
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
      <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Data&nbsp;Structures</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div class="tabs">
    <ul>
      <li><a href="files.html"><span>File&nbsp;List</span></a></li>
      <li><a href="globals.html"><span>Globals</span></a></li>
    </ul>
  </div>
  <div class="navpath"><a class="el" href="dir_ad708b1050ae8d6cbaec86d45edda6ed.html">tools</a>&nbsp;&raquo;&nbsp;<a class="el" href="dir_4f30efbf64aa16c86f5902b19fc3ba4e.html">gmsh</a>
  </div>
</div>
<div class="contents">
<h1>gmshtoucd.py</h1><a href="gmshtoucd_8py.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a><a class="code" href="namespacegmshtoucd.html">00001</a> <span class="comment">#!/usr/bin/env python</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="stringliteral">&quot;&quot;&quot;</span>
<a name="l00004"></a>00004 <span class="stringliteral">gmshtoucd - converts Gmsh mesh files into unstructured cell data format</span>
<a name="l00005"></a>00005 <span class="stringliteral"></span>
<a name="l00006"></a>00006 <span class="stringliteral">Copyright (C) 2002-2010 Werner Scholz, Richard Boardman, Hans Fangohr</span>
<a name="l00007"></a>00007 <span class="stringliteral"></span>
<a name="l00008"></a>00008 <span class="stringliteral">gmshtoucd is free software; you can redistribute it and/or modify it</span>
<a name="l00009"></a>00009 <span class="stringliteral">under the terms of the GNU General Public License as published by the</span>
<a name="l00010"></a>00010 <span class="stringliteral">Free Software Foundation; either version 2</span>
<a name="l00011"></a>00011 <span class="stringliteral"></span>
<a name="l00012"></a>00012 <span class="stringliteral">gmshtoucd is distributed in the hope that it will be useful, but WITHOUT</span>
<a name="l00013"></a>00013 <span class="stringliteral">ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or</span>
<a name="l00014"></a>00014 <span class="stringliteral">FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License</span>
<a name="l00015"></a>00015 <span class="stringliteral">for more details.</span>
<a name="l00016"></a>00016 <span class="stringliteral"></span>
<a name="l00017"></a>00017 <span class="stringliteral">You should have received a copy of the GNU General Public License</span>
<a name="l00018"></a>00018 <span class="stringliteral">along with magpar; if not, write to the Free Software Foundation,</span>
<a name="l00019"></a>00019 <span class="stringliteral">Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA</span>
<a name="l00020"></a>00020 <span class="stringliteral"></span>
<a name="l00021"></a>00021 <span class="stringliteral">This program was designed for magpar, so results may</span>
<a name="l00022"></a>00022 <span class="stringliteral">vary when used with other programs accepting AVS/UCD</span>
<a name="l00023"></a>00023 <span class="stringliteral">as an input file format</span>
<a name="l00024"></a>00024 <span class="stringliteral"></span>
<a name="l00025"></a>00025 <span class="stringliteral">This program is based on ngtoucd by Richard Boardman, Hans Fangohr.</span>
<a name="l00026"></a>00026 <span class="stringliteral"></span>
<a name="l00027"></a>00027 <span class="stringliteral">&quot;&quot;&quot;</span>
<a name="l00028"></a>00028 
<a name="l00029"></a><a class="code" href="namespacegmshtoucd.html#a1b6e9cd423c0f6fea9278e4f78e34446">00029</a> VERSION=<span class="stringliteral">&quot;0.1&quot;</span>
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 <span class="keyword">import</span> os, string, sys, time
<a name="l00032"></a>00032 
<a name="l00033"></a><a class="code" href="namespacegmshtoucd.html#a0e46ab32b2ad7911566353ac4f869e7d">00033</a> <span class="keyword">def </span><a class="code" href="namespacegmshtoucd.html#a0e46ab32b2ad7911566353ac4f869e7d">readmesh</a>(filename):
<a name="l00034"></a>00034     <span class="stringliteral">&quot;&quot;&quot;This will read the Gmsh mesh &#39;filename&#39; and return</span>
<a name="l00035"></a>00035 <span class="stringliteral">    points, tetrahedra and triangles&quot;&quot;&quot;</span>
<a name="l00036"></a>00036 
<a name="l00037"></a>00037     <span class="comment"># expected Gmsh msh file format:</span>
<a name="l00038"></a>00038     <span class="comment"># http://www.geuz.org/gmsh/doc/texinfo/gmsh_10.html#SEC62</span>
<a name="l00039"></a>00039     
<a name="l00040"></a>00040     f = open(filename, <span class="stringliteral">&#39;</span><span class="stringliteral">r&#39;)</span>
<a name="l00041"></a>00041 <span class="stringliteral"></span>
<a name="l00042"></a>00042 <span class="stringliteral">    </span><span class="comment">#################################################################</span>
<a name="l00043"></a>00043     <span class="comment">#</span>
<a name="l00044"></a>00044     <span class="comment"># read the first line to get the number of points</span>
<a name="l00045"></a>00045     <span class="comment">#</span>
<a name="l00046"></a>00046     <span class="comment">#################################################################</span>
<a name="l00047"></a>00047 
<a name="l00048"></a>00048     thisline = f.readline()
<a name="l00049"></a>00049     <span class="keywordflow">if</span> thisline != <span class="stringliteral">&quot;$MeshFormat\n&quot;</span> :
<a name="l00050"></a>00050         bail(<span class="stringliteral">&quot;Unexpected input &quot;</span> + thisline)
<a name="l00051"></a>00051 
<a name="l00052"></a>00052     thisline = f.readline()
<a name="l00053"></a>00053     segments  = string.split(thisline[:-1])
<a name="l00054"></a>00054     <span class="comment"># `.msh&#39; file format, version 2.0</span>
<a name="l00055"></a>00055     <span class="keywordflow">if</span> segments[0] != <span class="stringliteral">&quot;2&quot;</span> <span class="keywordflow">and</span> segments[0] != <span class="stringliteral">&quot;2.1&quot;</span>:
<a name="l00056"></a>00056       bail(<span class="stringliteral">&quot;Unexpected input &quot;</span> + thisline)
<a name="l00057"></a>00057     <span class="comment"># file-type: ASCII format</span>
<a name="l00058"></a>00058     <span class="keywordflow">if</span> int(segments[1])!=0 :
<a name="l00059"></a>00059       bail(<span class="stringliteral">&quot;Unexpected input &quot;</span> + thisline)
<a name="l00060"></a>00060     <span class="comment"># data-size (ignored)</span>
<a name="l00061"></a>00061 
<a name="l00062"></a>00062     thisline = f.readline()
<a name="l00063"></a>00063     <span class="keywordflow">if</span> thisline != <span class="stringliteral">&quot;$EndMeshFormat\n&quot;</span> :
<a name="l00064"></a>00064         bail(<span class="stringliteral">&quot;Unexpected input &quot;</span> + thisline)
<a name="l00065"></a>00065 
<a name="l00066"></a>00066     <span class="comment">#################################################################</span>
<a name="l00067"></a>00067     <span class="comment">#</span>
<a name="l00068"></a>00068     <span class="comment"># read the points</span>
<a name="l00069"></a>00069     <span class="comment">#</span>
<a name="l00070"></a>00070     <span class="comment">#################################################################</span>
<a name="l00071"></a>00071 
<a name="l00072"></a>00072     thisline = f.readline()
<a name="l00073"></a>00073     <span class="keywordflow">if</span> thisline != <span class="stringliteral">&quot;$Nodes\n&quot;</span> :
<a name="l00074"></a>00074         bail(<span class="stringliteral">&quot;Unexpected input &quot;</span> + thisline)
<a name="l00075"></a>00075       
<a name="l00076"></a>00076     thisline = f.readline()
<a name="l00077"></a>00077     number_of_points = int(thisline)
<a name="l00078"></a>00078 
<a name="l00079"></a>00079     points = []
<a name="l00080"></a>00080 
<a name="l00081"></a>00081     <span class="keywordflow">for</span> i <span class="keywordflow">in</span> range(number_of_points):
<a name="l00082"></a>00082         thisline  = f.readline()
<a name="l00083"></a>00083         segments  = string.split(thisline[:-1])
<a name="l00084"></a>00084         thispoint = list(map(<span class="keyword">lambda</span> p: float(p), segments[1:4]))
<a name="l00085"></a>00085         points.append(thispoint)
<a name="l00086"></a>00086 
<a name="l00087"></a>00087     thisline = f.readline()
<a name="l00088"></a>00088     <span class="keywordflow">if</span> thisline != <span class="stringliteral">&quot;$EndNodes\n&quot;</span> :
<a name="l00089"></a>00089         bail(<span class="stringliteral">&quot;Unexpected input &quot;</span> + thisline)
<a name="l00090"></a>00090       
<a name="l00091"></a>00091     <span class="comment">#################################################################</span>
<a name="l00092"></a>00092     <span class="comment">#</span>
<a name="l00093"></a>00093     <span class="comment"># now read all the volume elements</span>
<a name="l00094"></a>00094     <span class="comment"># first, ascertain the number of volume elements</span>
<a name="l00095"></a>00095     <span class="comment">#</span>
<a name="l00096"></a>00096     <span class="comment">#################################################################</span>
<a name="l00097"></a>00097 
<a name="l00098"></a>00098     thisline = f.readline()
<a name="l00099"></a>00099     <span class="keywordflow">if</span> thisline != <span class="stringliteral">&quot;$Elements\n&quot;</span> :
<a name="l00100"></a>00100         bail(<span class="stringliteral">&quot;Unexpected input &quot;</span> + thisline)
<a name="l00101"></a>00101       
<a name="l00102"></a>00102     thisline             = f.readline()
<a name="l00103"></a>00103     number_of_elements   = int(thisline)
<a name="l00104"></a>00104 
<a name="l00105"></a>00105     <span class="comment">#################################################################</span>
<a name="l00106"></a>00106     <span class="comment">#</span>
<a name="l00107"></a>00107     <span class="comment"># then read and populate, keeping track</span>
<a name="l00108"></a>00108     <span class="comment"># of the tetrahedra subdomain</span>
<a name="l00109"></a>00109     <span class="comment">#</span>
<a name="l00110"></a>00110     <span class="comment">#################################################################</span>
<a name="l00111"></a>00111     
<a name="l00112"></a>00112     triangles           = []
<a name="l00113"></a>00113     triangles_subdomain = []
<a name="l00114"></a>00114 
<a name="l00115"></a>00115     tetrahedra           = []
<a name="l00116"></a>00116     tetrahedra_subdomain = []
<a name="l00117"></a>00117 
<a name="l00118"></a>00118     triangles_id=0
<a name="l00119"></a>00119     tetrahedra_id=0
<a name="l00120"></a>00120 
<a name="l00121"></a>00121     <span class="keywordflow">for</span> i <span class="keywordflow">in</span> range(number_of_elements):
<a name="l00122"></a>00122         thisline = f.readline()
<a name="l00123"></a>00123         segments = string.split(thisline[:-1])
<a name="l00124"></a>00124         tags = int(segments[2])
<a name="l00125"></a>00125 
<a name="l00126"></a>00126         <span class="comment"># element type 2: 3 node triangle</span>
<a name="l00127"></a>00127         <span class="keywordflow">if</span> int(segments[1]) == 2 :
<a name="l00128"></a>00128             segments = string.split(thisline[:-1])
<a name="l00129"></a>00129             <span class="keywordflow">if</span> len(segments) != 6+tags:
<a name="l00130"></a>00130                 <span class="keywordflow">print</span> <span class="stringliteral">&quot;Found&quot;</span>, len(segments), <span class="stringliteral">&quot;elements, but expected &quot;</span>, 6+tags
<a name="l00131"></a>00131                 <span class="keywordflow">print</span> segments
<a name="l00132"></a>00132                 <span class="keywordflow">raise</span> <span class="stringliteral">&quot;Oops&quot;</span>, <span class="stringliteral">&quot;File format error&quot;</span>
<a name="l00133"></a>00133 
<a name="l00134"></a>00134             triangles_subdomain.append(triangles_id)
<a name="l00135"></a>00135             <span class="comment"># similar adjustment for materials as with tetrahedra</span>
<a name="l00136"></a>00136             triangle = [list(map(<span class="keyword">lambda</span> t : int(t)-1, segments[3+tags:5+tags])), int(segments[3])]
<a name="l00137"></a>00137             triangles.append(triangle)
<a name="l00138"></a>00138             triangles_id=triangles_id+1
<a name="l00139"></a>00139 
<a name="l00140"></a>00140         <span class="comment"># element type 4: 4 node tetrahedron</span>
<a name="l00141"></a>00141         <span class="keywordflow">if</span> int(segments[1]) == 4 :
<a name="l00142"></a>00142             <span class="keywordflow">if</span> len(segments) != 7+tags:
<a name="l00143"></a>00143                 <span class="keywordflow">print</span> <span class="stringliteral">&quot;Found&quot;</span>, len(segments), <span class="stringliteral">&quot;elements, but expected &quot;</span>, 7+tags
<a name="l00144"></a>00144                 <span class="keywordflow">print</span> segments
<a name="l00145"></a>00145                 <span class="keywordflow">raise</span> <span class="stringliteral">&quot;Oops&quot;</span>, <span class="stringliteral">&quot;File format error&quot;</span>
<a name="l00146"></a>00146 
<a name="l00147"></a>00147             tetrahedra_subdomain.append(tetrahedra_id)
<a name="l00148"></a>00148 
<a name="l00149"></a>00149             <span class="comment"># rpb, 17th March 2006 - updated to handle materials (note:</span>
<a name="l00150"></a>00150             <span class="comment"># in Gmsh these are top-level objects [tlos])</span>
<a name="l00151"></a>00151             <span class="comment"># original mapping was [a, b, c, d] (where a-d are points)</span>
<a name="l00152"></a>00152             <span class="comment"># new mapping is [[a,b,c,d],m] (where m is a material ID)</span>
<a name="l00153"></a>00153             tetrahedron = [list(map(<span class="keyword">lambda</span> t : int(t)-1, segments[3+tags:7+tags])), int(segments[3])]
<a name="l00154"></a>00154 
<a name="l00155"></a>00155             <span class="comment"># Gmsh counts from 1 rather than from 0, hence int(t)-1</span>
<a name="l00156"></a>00156 
<a name="l00157"></a>00157             tetrahedra.append(tetrahedron)
<a name="l00158"></a>00158             tetrahedra_id=tetrahedra_id+1
<a name="l00159"></a>00159 
<a name="l00160"></a>00160     thisline = f.readline()
<a name="l00161"></a>00161     <span class="keywordflow">if</span> thisline != <span class="stringliteral">&quot;$EndElements\n&quot;</span> :
<a name="l00162"></a>00162         bail(<span class="stringliteral">&quot;Unexpected input &quot;</span> + thisline)
<a name="l00163"></a>00163       
<a name="l00164"></a>00164     <span class="comment">#################################################################</span>
<a name="l00165"></a>00165     <span class="comment">#</span>
<a name="l00166"></a>00166     <span class="comment"># send back the read mesh</span>
<a name="l00167"></a>00167     <span class="comment">#</span>
<a name="l00168"></a>00168     <span class="comment">#################################################################</span>
<a name="l00169"></a>00169     
<a name="l00170"></a>00170     <span class="keywordflow">return</span> (points, tetrahedra, triangles, tetrahedra_subdomain, triangles_subdomain)
<a name="l00171"></a>00171 
<a name="l00172"></a><a class="code" href="namespacegmshtoucd.html#a51edbb6500af1b05164cecb5e75f705f">00172</a> <span class="keyword">def </span><a class="code" href="namespacegmshtoucd.html#a51edbb6500af1b05164cecb5e75f705f">bail</a>(message=&quot;Sorry, I don&#39;t understand. Bailing out...&quot;):
<a name="l00173"></a>00173     <span class="stringliteral">&quot;&quot;&quot;A &#39;get-out&#39; clause&quot;&quot;&quot;</span>
<a name="l00174"></a>00174     <span class="keywordflow">print</span> message
<a name="l00175"></a>00175     sys.exit(1)
<a name="l00176"></a>00176 
<a name="l00177"></a><a class="code" href="namespacegmshtoucd.html#a2ebadbc8e24fa0f396c534b63bfc1302">00177</a> <span class="keyword">def </span><a class="code" href="namespacegmshtoucd.html#a2ebadbc8e24fa0f396c534b63bfc1302">initialise_file</a>(file):
<a name="l00178"></a>00178     <span class="stringliteral">&quot;&quot;&quot;Attempt to remove the file first to avoid append issues&quot;&quot;&quot;</span>
<a name="l00179"></a>00179     <span class="keywordflow">try</span>:
<a name="l00180"></a>00180         os.remove(file)
<a name="l00181"></a>00181     <span class="keywordflow">except</span>:
<a name="l00182"></a>00182         <span class="comment"># no problem</span>
<a name="l00183"></a>00183         <span class="keywordflow">pass</span>
<a name="l00184"></a>00184 
<a name="l00185"></a><a class="code" href="namespacegmshtoucd.html#afe46d94d6118bbc73f694e0e1904ddee">00185</a> <span class="keyword">def </span><a class="code" href="namespacegmshtoucd.html#afe46d94d6118bbc73f694e0e1904ddee">writeln</a>(line, file):
<a name="l00186"></a>00186     <span class="stringliteral">&quot;&quot;&quot;One-shot file line append; this keeps the code terse&quot;&quot;&quot;</span>
<a name="l00187"></a>00187     f = open(file, <span class="stringliteral">&#39;a&#39;</span>)
<a name="l00188"></a>00188     f.write(line + <span class="stringliteral">&#39;\n&#39;</span>)
<a name="l00189"></a>00189     f.close()
<a name="l00190"></a>00190 
<a name="l00191"></a><a class="code" href="namespacegmshtoucd.html#afa7a5c0943712b0b7f09170ae2f7e62f">00191</a> <span class="keyword">def </span><a class="code" href="namespacegmshtoucd.html#afa7a5c0943712b0b7f09170ae2f7e62f">stamp</a>():
<a name="l00192"></a>00192     <span class="stringliteral">&quot;&quot;&quot;Format a time and a date for stdout feedback&quot;&quot;&quot;</span>
<a name="l00193"></a>00193     thistime = time.localtime()
<a name="l00194"></a>00194     <span class="keywordflow">return</span> <span class="stringliteral">&quot;[%04d/%02d/%02d %02d:%02d:%02d] &quot;</span> % (thistime[0],
<a name="l00195"></a>00195                                                  thistime[1],
<a name="l00196"></a>00196                                                  thistime[2],
<a name="l00197"></a>00197                                                  thistime[3],
<a name="l00198"></a>00198                                                  thistime[4],
<a name="l00199"></a>00199                                                  thistime[5])
<a name="l00200"></a>00200 
<a name="l00201"></a>00201 
<a name="l00202"></a><a class="code" href="namespacegmshtoucd.html#af68c1546c900f7a17a20835183320d61">00202</a> <span class="keyword">def </span><a class="code" href="namespacegmshtoucd.html#af68c1546c900f7a17a20835183320d61">info</a>():
<a name="l00203"></a>00203     <span class="stringliteral">&quot;&quot;&quot;Output GPL details&quot;&quot;&quot;</span>
<a name="l00204"></a>00204     <span class="keywordflow">print</span> <span class="stringliteral">&quot;&quot;&quot;gmshtoucd, Copyright (C) 2002-2010</span>
<a name="l00205"></a>00205 <span class="stringliteral">             Werner Scholz, Richard Boardman, Hans Fangohr</span>
<a name="l00206"></a>00206 <span class="stringliteral">             gmshtoucd comes with ABSOLUTELY NO WARRANTY;</span>
<a name="l00207"></a>00207 <span class="stringliteral">             for details see the file COPYING&quot;&quot;&quot;</span>
<a name="l00208"></a>00208 
<a name="l00209"></a><a class="code" href="namespacegmshtoucd.html#a236f16b4f0c25d8c6e098ad7468acca7">00209</a> <span class="keyword">def </span><a class="code" href="namespacegmshtoucd.html#a236f16b4f0c25d8c6e098ad7468acca7">writeucd</a>():
<a name="l00210"></a>00210     <span class="stringliteral">&quot;&quot;&quot;Call readmesh to read the Gmsh mesh, then convert and write the UCD mesh&quot;&quot;&quot;</span>
<a name="l00211"></a>00211     al = len(sys.argv)
<a name="l00212"></a>00212     <span class="keywordflow">if</span> al &lt; 2 <span class="keywordflow">or</span> al &gt; 3 <span class="keywordflow">or</span> sys.argv[1] == <span class="stringliteral">&#39;--help&#39;</span> <span class="keywordflow">or</span> sys.argv[1] == <span class="stringliteral">&#39;-h&#39;</span>:
<a name="l00213"></a>00213         bail(<span class="stringliteral">&quot;Usage: &quot;</span> + sys.argv[0] + <span class="stringliteral">&quot; gmsh.msh [ucdmesh.inp]&quot;</span>)
<a name="l00214"></a>00214 
<a name="l00215"></a>00215     inputfile = sys.argv[1]
<a name="l00216"></a>00216 
<a name="l00217"></a>00217     <span class="keywordflow">if</span> len(sys.argv) == 3:
<a name="l00218"></a>00218         outputfile = sys.argv[2]
<a name="l00219"></a>00219     <span class="keywordflow">else</span>:
<a name="l00220"></a>00220         outputfile = os.path.splitext(inputfile)[0] + <span class="stringliteral">&quot;.inp&quot;</span>
<a name="l00221"></a>00221 
<a name="l00222"></a>00222     <span class="keywordflow">print</span>
<a name="l00223"></a>00223     <span class="keywordflow">print</span> <span class="stringliteral">&quot;About to read, check and process the gmsh file &quot;</span>, inputfile
<a name="l00224"></a>00224     <span class="keywordflow">print</span> <span class="stringliteral">&quot;and then create the AVS/UCD mesh&quot;</span>, outputfile
<a name="l00225"></a>00225     <span class="keywordflow">print</span>
<a name="l00226"></a>00226 
<a name="l00227"></a>00227     <span class="keywordflow">print</span> stamp() + <span class="stringliteral">&quot;Initialising file&quot;</span> + outputfile
<a name="l00228"></a>00228     initialise_file(outputfile)
<a name="l00229"></a>00229     <span class="keywordflow">print</span> stamp() + <span class="stringliteral">&quot;File &quot;</span> + outputfile + <span class="stringliteral">&quot; initialised&quot;</span>
<a name="l00230"></a>00230 
<a name="l00231"></a>00231     <span class="keywordflow">print</span> stamp() + <span class="stringliteral">&quot;Attemping read of input &quot;</span> + inputfile
<a name="l00232"></a>00232     (points, tetrahedra, triangles, tetrasub, trisub) = readmesh(inputfile)
<a name="l00233"></a>00233     <span class="keywordflow">print</span> stamp() + <span class="stringliteral">&quot;Input file successfully read&quot;</span>
<a name="l00234"></a>00234 
<a name="l00235"></a>00235     <span class="keywordflow">print</span> stamp() + <span class="stringliteral">&quot;Points:     %d&quot;</span> % len(points)
<a name="l00236"></a>00236     <span class="keywordflow">print</span> stamp() + <span class="stringliteral">&quot;Tetrahedra: %d [%d in subdomain]&quot;</span> % (len(tetrahedra), len(tetrasub))
<a name="l00237"></a>00237     <span class="keywordflow">print</span> stamp() + <span class="stringliteral">&quot;Triangles:  %d [%d in subdomain]&quot;</span> % (len(triangles),  len(trisub))
<a name="l00238"></a>00238 
<a name="l00239"></a>00239     <span class="comment">#################################################################</span>
<a name="l00240"></a>00240     <span class="comment">#</span>
<a name="l00241"></a>00241     <span class="comment"># the first line of a UCD file reads:</span>
<a name="l00242"></a>00242     <span class="comment"># a b c d e</span>
<a name="l00243"></a>00243     <span class="comment">#</span>
<a name="l00244"></a>00244     <span class="comment"># where a is the number of nodes</span>
<a name="l00245"></a>00245     <span class="comment">#       b is the number of cells</span>
<a name="l00246"></a>00246     <span class="comment">#       c is the length of vector data associated with the nodes</span>
<a name="l00247"></a>00247     <span class="comment">#       d is the length of vector data associated with the cells</span>
<a name="l00248"></a>00248     <span class="comment">#       e is the length of vector data associated with the model</span>
<a name="l00249"></a>00249     <span class="comment">#</span>
<a name="l00250"></a>00250     <span class="comment"># example: 12 2 1 0 0</span>
<a name="l00251"></a>00251     <span class="comment">#</span>
<a name="l00252"></a>00252     <span class="comment">#################################################################</span>
<a name="l00253"></a>00253 
<a name="l00254"></a>00254     <span class="comment"># n.b. here the third integer indicates the number of placeholders</span>
<a name="l00255"></a>00255     
<a name="l00256"></a>00256     <span class="keywordflow">print</span> stamp() + <span class="stringliteral">&quot;Creating descriptor [UCD]&quot;</span>
<a name="l00257"></a>00257     writeln(str(len(points)) + <span class="stringliteral">&quot; &quot;</span> + str(len(tetrahedra)) + <span class="stringliteral">&quot; 3 0 0&quot;</span>, outputfile)
<a name="l00258"></a>00258     <span class="keywordflow">print</span> stamp() + <span class="stringliteral">&quot;UCD descriptor created&quot;</span>
<a name="l00259"></a>00259     
<a name="l00260"></a>00260     <span class="comment">#################################################################</span>
<a name="l00261"></a>00261     <span class="comment">#</span>
<a name="l00262"></a>00262     <span class="comment"># then we have nodes in threespace, one line per node</span>
<a name="l00263"></a>00263     <span class="comment"># n x y z</span>
<a name="l00264"></a>00264     <span class="comment"># where n is the node ID -- integer (not necessarily sequential)</span>
<a name="l00265"></a>00265     <span class="comment">#       x,y,z are the x, y and z coordinates</span>
<a name="l00266"></a>00266     <span class="comment">#</span>
<a name="l00267"></a>00267     <span class="comment">#################################################################</span>
<a name="l00268"></a>00268 
<a name="l00269"></a>00269     <span class="keywordflow">print</span> stamp() + <span class="stringliteral">&quot;Now converting nodes&quot;</span>
<a name="l00270"></a>00270     <span class="keywordflow">for</span> i <span class="keywordflow">in</span> range(len(points)):
<a name="l00271"></a>00271         x, y, z = points[i][0], points[i][1], points[i][2]
<a name="l00272"></a>00272         writeln(str(i+1) + <span class="stringliteral">&quot; &quot;</span> + str(x) + <span class="stringliteral">&quot; &quot;</span> + str(y) + <span class="stringliteral">&quot; &quot;</span> + str(z), outputfile)
<a name="l00273"></a>00273     <span class="keywordflow">print</span> stamp() + <span class="stringliteral">&quot;Nodes converted&quot;</span>
<a name="l00274"></a>00274 
<a name="l00275"></a>00275     <span class="comment">#################################################################</span>
<a name="l00276"></a>00276     <span class="comment">#</span>
<a name="l00277"></a>00277     <span class="comment"># now the cells, one line/cell:</span>
<a name="l00278"></a>00278     <span class="comment">#</span>
<a name="l00279"></a>00279     <span class="comment"># c m t n1 n2 ... nn</span>
<a name="l00280"></a>00280     <span class="comment">#</span>
<a name="l00281"></a>00281     <span class="comment"># where c is the cell ID</span>
<a name="l00282"></a>00282     <span class="comment">#       m is the material type (int, leave as 1 if we don&#39;t care)</span>
<a name="l00283"></a>00283     <span class="comment">#       t is the cell type (prism|hex|pyr|tet|quad|tri|line|pt)</span>
<a name="l00284"></a>00284     <span class="comment">#       n1...nn is a node ID list corresponding to cell vertices</span>
<a name="l00285"></a>00285     <span class="comment">#</span>
<a name="l00286"></a>00286     <span class="comment">#################################################################</span>
<a name="l00287"></a>00287 
<a name="l00288"></a>00288     cellctr = 0
<a name="l00289"></a>00289 
<a name="l00290"></a>00290     <span class="keywordflow">print</span> stamp() + <span class="stringliteral">&quot;Converting tetrahedra&quot;</span>
<a name="l00291"></a>00291 
<a name="l00292"></a>00292     <span class="keywordflow">for</span> tetra <span class="keywordflow">in</span> tetrahedra:
<a name="l00293"></a>00293         tet = tetra[0] <span class="comment"># just the tetrahedron; tetra[1] is the material</span>
<a name="l00294"></a>00294         tetorder  = [0, 1, 2, 3]
<a name="l00295"></a>00295         tetstring =  <span class="stringliteral">&quot; &quot;</span> + str(tet[tetorder[0]]+1)
<a name="l00296"></a>00296         tetstring += <span class="stringliteral">&quot; &quot;</span> + str(tet[tetorder[1]]+1)
<a name="l00297"></a>00297         tetstring += <span class="stringliteral">&quot; &quot;</span> + str(tet[tetorder[2]]+1)
<a name="l00298"></a>00298         tetstring += <span class="stringliteral">&quot; &quot;</span> + str(tet[tetorder[3]]+1)
<a name="l00299"></a>00299         writeln(str(cellctr+1) + <span class="stringliteral">&quot; &quot;</span> + str(tetra[1]) + <span class="stringliteral">&quot; tet&quot;</span> + tetstring, outputfile)
<a name="l00300"></a>00300         cellctr   += 1
<a name="l00301"></a>00301 
<a name="l00302"></a>00302     <span class="keywordflow">print</span> stamp() + <span class="stringliteral">&quot;Tetrahedra converted&quot;</span>
<a name="l00303"></a>00303 
<a name="l00304"></a>00304     <span class="comment">#################################################################</span>
<a name="l00305"></a>00305     <span class="comment">#</span>
<a name="l00306"></a>00306     <span class="comment"># uncomment the following section to convert triangles as well</span>
<a name="l00307"></a>00307     <span class="comment"># - since magpar will ignore these, leave away for the time being</span>
<a name="l00308"></a>00308     <span class="comment">#</span>
<a name="l00309"></a>00309     <span class="comment"># print stamp() + &quot;Converting triangles&quot;</span>
<a name="l00310"></a>00310     <span class="comment">#</span>
<a name="l00311"></a>00311     <span class="comment"># cellctr = 0</span>
<a name="l00312"></a>00312     <span class="comment"># for triang in triangles:</span>
<a name="l00313"></a>00313     <span class="comment">#     tri = triang[0] # just the triangle; triang[1] is the material</span>
<a name="l00314"></a>00314     <span class="comment">#     tristring = &quot;&quot;</span>
<a name="l00315"></a>00315     <span class="comment">#     for node in tri:</span>
<a name="l00316"></a>00316     <span class="comment">#         tristring += &quot; &quot; + str(node+1)</span>
<a name="l00317"></a>00317     <span class="comment">#     writeln(str(cellctr+1) + &quot; &quot; + str(triang[1]) + &quot; tri&quot; + ts, outputfile)</span>
<a name="l00318"></a>00318     <span class="comment">#</span>
<a name="l00319"></a>00319     <span class="comment"># print stamp() + &quot;Triangles converted&quot;</span>
<a name="l00320"></a>00320     <span class="comment">#</span>
<a name="l00321"></a>00321     <span class="comment">#################################################################</span>
<a name="l00322"></a>00322 
<a name="l00323"></a>00323     <span class="comment">#################################################################</span>
<a name="l00324"></a>00324     <span class="comment">#</span>
<a name="l00325"></a>00325     <span class="comment"># for the data vector associated with the nodes:</span>
<a name="l00326"></a>00326     <span class="comment">#</span>
<a name="l00327"></a>00327     <span class="comment"># first line tells us into which components the vector is divided</span>
<a name="l00328"></a>00328     <span class="comment">#</span>
<a name="l00329"></a>00329     <span class="comment">#   example: vector of 5 floats could be 3 3 1 1</span>
<a name="l00330"></a>00330     <span class="comment">#            node scalar could be 1 1</span>
<a name="l00331"></a>00331     <span class="comment">#</span>
<a name="l00332"></a>00332     <span class="comment"># next lines, for each data component, use a cs label/unit pair</span>
<a name="l00333"></a>00333     <span class="comment">#</span>
<a name="l00334"></a>00334     <span class="comment">#   example: temperature, kelvin</span>
<a name="l00335"></a>00335     <span class="comment">#</span>
<a name="l00336"></a>00336     <span class="comment"># subsequent lines, for each node, the vector of associated data</span>
<a name="l00337"></a>00337     <span class="comment"># in this order</span>
<a name="l00338"></a>00338     <span class="comment">#</span>
<a name="l00339"></a>00339     <span class="comment">#   example: 1 10\n2 15\n3 12.4\n4 9</span>
<a name="l00340"></a>00340     <span class="comment">#</span>
<a name="l00341"></a>00341     <span class="comment">#################################################################</span>
<a name="l00342"></a>00342 
<a name="l00343"></a>00343     <span class="keywordflow">print</span> stamp() + <span class="stringliteral">&quot;Initialising placeholders&quot;</span>
<a name="l00344"></a>00344 
<a name="l00345"></a>00345     writeln(<span class="stringliteral">&quot;3 1 1 1&quot;</span>, outputfile)
<a name="l00346"></a>00346     writeln(<span class="stringliteral">&quot;M_x, none&quot;</span>, outputfile)
<a name="l00347"></a>00347     writeln(<span class="stringliteral">&quot;M_y, none&quot;</span>, outputfile)
<a name="l00348"></a>00348     writeln(<span class="stringliteral">&quot;M_z, none&quot;</span>, outputfile)
<a name="l00349"></a>00349     
<a name="l00350"></a>00350     <span class="comment">#################################################################</span>
<a name="l00351"></a>00351     <span class="comment">#</span>
<a name="l00352"></a>00352     <span class="comment"># create some initial scalar values; here, generally</span>
<a name="l00353"></a>00353     <span class="comment"># +x=1.0 +y=+z=0.01*x (everything else)=&quot;\epsilon&quot;</span>
<a name="l00354"></a>00354     <span class="comment">#</span>
<a name="l00355"></a>00355     <span class="comment">#################################################################</span>
<a name="l00356"></a>00356 
<a name="l00357"></a>00357     scalarstring =  <span class="stringliteral">&quot; 1.0 0.0 0.0&quot;</span>
<a name="l00358"></a>00358 
<a name="l00359"></a>00359     <span class="keywordflow">for</span> i <span class="keywordflow">in</span> range(len(points)):
<a name="l00360"></a>00360         writeln(str(i+1) + scalarstring, outputfile)
<a name="l00361"></a>00361 
<a name="l00362"></a>00362     <span class="keywordflow">print</span> stamp() + <span class="stringliteral">&quot;Placeholders inserted&quot;</span>
<a name="l00363"></a>00363 
<a name="l00364"></a>00364     <span class="comment"># all done</span>
<a name="l00365"></a>00365 
<a name="l00366"></a>00366     <span class="keywordflow">print</span> stamp() + <span class="stringliteral">&quot;All finished&quot;</span>
<a name="l00367"></a>00367 
<a name="l00368"></a>00368 
<a name="l00369"></a>00369     
<a name="l00370"></a>00370 <span class="keywordflow">if</span> __name__==<span class="stringliteral">&quot;__main__&quot;</span>:
<a name="l00371"></a>00371     writeucd()
</pre></div></div>
  <hr>
  <address>
    magpar - Parallel Finite Element Micromagnetics Package<br>
    Copyright (C) 2002-2010 Werner Scholz
  </address>
  </body>
</html>

